#include <iostream>  
using namespace std;



int main()
{

	int a = 10;
	int b = 42;
	int &r = b; // Type: int &, that is a reference to an int
	int *c; // Unintialized pointer // Type int *, i.e., pointer to an int
	// c might refer to something invalid.
	// cout << "*c = " << *c << endl;
	// a wary of dereferencing an uninitalized variable	
	c = &b; // Sets up c to refer to b.
	//  ^---- means "address of" b

	cout << "a = " << a << endl;
	cout << "b = " << b << endl;
	cout << "c = " << c << endl;
	cout << "*c = " << *c << endl;
	//       ^---- means "thing referred to by" c
	cout << "r = " << r << endl;

	*c = *c + 100; // This is effectively b = b + 100;

	cout << endl;
	cout << "a = " << a << endl;
	cout << "b = " << b << endl;
	cout << "c = " << c << endl;
	cout << "*c = " << *c << endl;

	/* This is a bug! DON'T DO THIS */
	c = c + 100; // This adds 100 to the memory location stored in c.
			// this is dangerous, b/c I don't know what that might be.

	cout << endl;
	cout << "a = " << a << endl;
	cout << "b = " << b << endl;
	cout << "c = " << c << endl; // The value from before, + 100
	cout << "*c = " << *c << endl; // Junk at this new location.

	c = &a;
	cout << endl;
	cout << "a = " << a << endl;
	cout << "b = " << b << endl;
	cout << "c = " << c << endl;
	cout << "*c = " << *c << endl;




	return 0;
}


